=== modified file 'NEWS'
--- NEWS	2010-12-01 08:21:27 +0000
+++ NEWS	2010-04-23 01:30:29 +0000
@@ -1,8 +1,8 @@
 What's changed in loggerhead?
 =============================
 
-1.18 [10Nov2010]
-----------------
+dev [future]
+------------
 
     - Syntax highlighting is no longer applied for files greater than 512K,
       reducing codebrowse.launchpad.net overloading.
@@ -25,15 +25,6 @@
     - Ignore readonly+ prefix when checking if Loggerhead is serving a
       local location. (Reported by Tres Seaver.) (Matt Nordhoff)
 
-    - Set Cache-Control and Expires headers on static pages.
-      (John Arbash Meinel)
-
-    - Generate relative links where possible (everywhere but HTTP
-      redirects and feed IDs). (Michael Hudson, Matt Nordhoff)
-
-    - Fix bad redirect when visiting "/download" or "/download/".
-      (Matt Nordhoff, #247992)
-
 
 1.17 [20Aug2009]
 ----------------

=== modified file '__init__.py'
--- __init__.py	2010-11-11 02:48:30 +0000
+++ __init__.py	2010-04-22 08:52:59 +0000
@@ -30,16 +30,15 @@
 starts a web server to browse the contents of a branch.
 """
 
-from info import (
-    bzr_plugin_version as version_info,
-    bzr_compatible_versions,
-    )
+version_info = (1, 17, 0)
 
 if __name__ == 'bzrlib.plugins.loggerhead':
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, bzr_compatible_versions)
+    require_any_api(bzrlib, [
+        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
+        (2, 0, 0), (2, 1, 0), (2, 2, 0)])
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
@@ -70,9 +69,10 @@
         logging.getLogger('simpleTAL').addHandler(handler)
         logging.getLogger('simpleTALES').addHandler(handler)
 
+    def serve_http(transport, host=None, port=None, inet=None):
+        from paste.httpexceptions import HTTPExceptionHandler
+        from paste.httpserver import serve
 
-    def _ensure_loggerhead_path():
-        """Ensure that you can 'import loggerhead' and get the root."""
         # loggerhead internal code will try to 'import loggerhead', so
         # let's put it on the path if we can't find it in the existing path
         try:
@@ -81,12 +81,6 @@
             import os.path, sys
             sys.path.append(os.path.dirname(__file__))
 
-    def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
-        _ensure_loggerhead_path()
-
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
 
@@ -138,9 +132,3 @@
                     super(cmd_serve, self).run(*args, **kw)
 
         register_command(cmd_serve)
-
-    def load_tests(standard_tests, module, loader):
-        _ensure_loggerhead_path()
-        standard_tests.addTests(loader.loadTestsFromModuleNames(
-            ['bzrlib.plugins.loggerhead.loggerhead.tests']))
-        return standard_tests

=== removed file 'info.py'
--- info.py	2011-02-09 22:33:14 +0000
+++ info.py	1970-01-01 00:00:00 +0000
@@ -1,14 +0,0 @@
-#!/usr/bin/env python
-# API Info for loggerhead
-
-bzr_plugin_name = "loggerhead"
-
-bzr_plugin_version = (1, 18, 0)
-
-bzr_compatible_versions = [
-    (1, 17, 0), (1, 18, 0), (2, 0, 0), (2, 1, 0), (2, 2, 0), (2, 3, 0),
-    (2, 4, 0)]
-
-bzr_minimum_version = bzr_compatible_versions[0]
-
-bzr_maximum_version = bzr_compatible_versions[-1]

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2010-11-11 03:30:43 +0000
+++ loggerhead/__init__.py	2009-08-20 13:30:37 +0000
@@ -22,7 +22,7 @@
 
 import pkg_resources
 
-__version__ = '1.18'
+__version__ = '1.17'
 required_bzrlib = (1, 17)
 
 pkg_resources.get_distribution('Paste>=1.6')

=== modified file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2010-04-30 21:30:18 +0000
+++ loggerhead/apps/__init__.py	2009-11-26 03:44:40 +0000
@@ -9,9 +9,7 @@
 static = os.path.join(
     os.path.dirname(os.path.dirname(__file__)), 'static')
 
-# Static things can be cached for half a day, we could probably make this
-# longer, except for just before rollout times.
-static_app = urlparser.make_static(None, static, cache_max_age=12*60*60)
+static_app = urlparser.make_static(None, static)
 
 favicon_app = convert_file_errors(fileapp.FileApp(
     os.path.join(static, 'images', 'favicon.ico')))

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2011-02-09 22:29:57 +0000
+++ loggerhead/apps/branch.py	2010-04-14 17:54:32 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008-2011 Canonical Ltd.
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,7 +29,6 @@
 
 from loggerhead.apps import static_app
 from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.view_ui import ViewUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.changelog_ui import ChangeLogUI
 from loggerhead.controllers.diff_ui import DiffUI
@@ -90,15 +89,10 @@
             if v is not None:
                 qs.append('%s=%s' % (k, urllib.quote(v)))
         qs = '&'.join(qs)
-        path_info = urllib.quote(
-            unicode('/'.join(args)).encode('utf-8'), safe='/~:')
-        if qs:
-            path_info += '?' + qs
-        return self._url_base + path_info
-
-    def absolute_url(self, *args, **kw):
-        rel_url = self.url(*args, **kw)
-        return request.resolve_relative_url(rel_url, self._environ)
+        return request.construct_url(
+            self._environ, script_name=self._url_base,
+            path_info=unicode('/'.join(args)).encode('utf-8'),
+            querystring=qs)
 
     def context_url(self, *args, **kw):
         kw = util.get_context(**kw)
@@ -125,7 +119,6 @@
         'files': InventoryUI,
         'revision': RevisionUI,
         'search': SearchUI,
-        'view': ViewUI,
         }
 
     def last_updated(self):
@@ -161,7 +154,7 @@
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(
-                self.absolute_url('/changes'))
+                self._url_base + '/changes')
         if path == 'static':
             return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
@@ -208,8 +208,8 @@
                                 environ['SCRIPT_NAME']
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             response = WSGIResponse()
             self.browse(response)

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/transport.py	2010-03-25 16:19:24 +0000
@@ -33,7 +33,6 @@
 from loggerhead.apps import favicon_app, robots_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-# TODO: Use bzrlib.ui.bool_from_string(), added in bzr 1.18
 _bools = {
     'yes': True, 'no': False,
     'on': True, 'off': False,
@@ -69,8 +68,8 @@
     def app_for_non_branch(self, environ):
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             if self.name:
                 name = self.name

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2011-01-20 07:28:21 +0000
+++ loggerhead/controllers/__init__.py	2009-10-17 08:59:33 +0000
@@ -17,10 +17,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import bzrlib.errors
 import time
 
-from paste.httpexceptions import HTTPNotFound
 from paste.request import path_info_pop, parse_querystring
 
 from loggerhead import util
@@ -114,10 +112,6 @@
         if h is None:
             return None
         if len(self.args) > 0 and self.args != ['']:
-            try:
-                revid = h.fix_revid(self.args[0])
-            except bzrlib.errors.NoSuchRevision:
-                raise HTTPNotFound;
+            return h.fix_revid(self.args[0])
         else:
-            revid = h.last_revid
-        return revid
+            return h.last_revid

=== renamed file 'loggerhead/controllers/view_ui.py' => 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/view_ui.py	2010-12-01 08:30:02 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
@@ -35,18 +35,20 @@
 from loggerhead import util
 
 
-class ViewUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.view'
-    
-    def tree_for(self, file_id, revid):
+class AnnotateUI(TemplatedBranchView):
+
+    template_path = 'loggerhead.templates.annotate'
+
+    def annotate_file(self, file_id, revid):
+        z = time.time()
+        lineno = 1
+        parity = 0
+
         file_revid = self._history.get_inventory(revid)[file_id].revision
-        return self._history._branch.repository.revision_tree(file_revid)
+        tree = self._history._branch.repository.revision_tree(file_revid)
 
-    def text_lines(self, file_id, revid):
         file_name = os.path.basename(self._history.get_path(revid, file_id))
-        
-        tree = self.tree_for(file_id, revid)
+
         file_text = tree.get_file_text(file_id)
         encoding = 'utf-8'
         try:
@@ -56,27 +58,44 @@
             file_text = file_text.decode(encoding)
 
         file_lines = bzrlib.osutils.split_lines(file_text)
-        # This can throw bzrlib.errors.BinaryFile (which our caller catches).
-        bzrlib.textfile.check_text_lines(file_lines)
-        
-        if highlight is not None:
-            hl_lines = highlight(file_name, file_text, encoding)
-            # highlight strips off extra newlines at the end of the file.
-            extra_lines = len(file_lines) - len(hl_lines)
-            hl_lines.extend([u''] * extra_lines)
-        else:
-            hl_lines = map(cgi.escape, file_lines)
-        
-        return hl_lines;
 
-    def file_contents(self, file_id, revid):
         try:
-            file_lines = self.text_lines(file_id, revid)
+            bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
             # bail out; this isn't displayable text
-            return ['(This is a binary file.)']
-
-        return file_lines
+            yield util.Container(parity=0, lineno=1, status='same',
+                                 text='(This is a binary file.)',
+                                 change=util.Container())
+        else:
+            if highlight is not None:
+                hl_lines = highlight(file_name, file_text, encoding)
+                hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
+            else:
+                hl_lines = map(cgi.escape, file_lines)
+
+            change_cache = {}
+
+            last_line_revid = None
+            for line_revid, text in tree.annotate_iter(file_id):
+                if line_revid == last_line_revid:
+                    # remember which lines have a new revno and which don't
+                    status = 'same'
+                else:
+                    status = 'changed'
+                    parity ^= 1
+                    last_line_revid = line_revid
+                    if line_revid in change_cache:
+                        change = change_cache[line_revid]
+                    else:
+                        change = self._history.get_changes([line_revid])[0]
+                        change_cache[line_revid] = change
+
+                yield util.Container(
+                    parity=parity, lineno=lineno, status=status,
+                    change=change, text=hl_lines[lineno - 1])
+                lineno += 1
+
+        self.log.debug('annotate: %r secs' % (time.time() - z,))
 
     def get_values(self, path, kwargs, headers):
         history = self._history
@@ -86,7 +105,7 @@
         file_id = kwargs.get('file_id', None)
         if (file_id is None) and (path is None):
             raise HTTPBadRequest('No file_id or filename '
-                                 'provided to view')
+                                 'provided to annotate')
 
         if file_id is None:
             file_id = history.get_file_id(revid, path)
@@ -121,17 +140,13 @@
         branch_breadcrumbs = util.branch_breadcrumbs(path, inv, 'files')
 
         return {
-            # In AnnotateUI, "annotated" is a generator giving revision
-            # numbers per lines, but the template checks if "annotated" is
-            # true or not before using it, so we have to define it here also.
-            'annotated': False,
             'revno_url': revno_url,
             'file_id': file_id,
-            'file_path': path,
+            'path': path,
             'filename': filename,
             'navigation': navigation,
             'change': change,
-            'contents':  self.file_contents(file_id, revid),
+            'contents': list(self.annotate_file(file_id, revid)),
             'fileview_active': True,
             'directory_breadcrumbs': directory_breadcrumbs,
             'branch_breadcrumbs': branch_breadcrumbs,

=== removed file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2010-12-01 08:30:02 +0000
+++ loggerhead/controllers/annotate_ui.py	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-#
-# Copyright (C) 2010 Canonical Ltd.
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-from loggerhead.controllers.view_ui import ViewUI
-from loggerhead import util
-
-class AnnotateUI(ViewUI):
-
-    def annotate_file(self, info):
-        file_id = info['file_id']
-        revid = info['change'].revid
-        
-        tree = self.tree_for(file_id, revid)
-        
-        change_cache = {}
-        last_line_revid = None
-        parity = 1
-        for line_revid, text in tree.annotate_iter(file_id):
-            if line_revid == last_line_revid:
-                # remember which lines have a new revno and which don't
-                new_rev = False
-            else:
-                new_rev = True
-                parity ^= 1
-                last_line_revid = line_revid
-                if line_revid in change_cache:
-                    change = change_cache[line_revid]
-                else:
-                    change = self._history.get_changes([line_revid])[0]
-                    change_cache[line_revid] = change
-
-            yield util.Container(
-                parity=parity, new_rev=new_rev, change=change)
-            
-    def get_values(self, path, kwargs, headers):
-        values = super(AnnotateUI, self).get_values(path, kwargs, headers)
-        values['annotated'] = self.annotate_file(values)
-        
-        return values

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2010-05-05 19:03:40 +0000
+++ loggerhead/controllers/download_ui.py	2010-04-08 01:08:33 +0000
@@ -44,8 +44,8 @@
             args.append(arg)
 
         if len(args) < 2:
-            raise httpexceptions.HTTPMovedPermanently(
-                self._branch.absolute_url('/changes'))
+            raise httpexceptions.HTTPMovedPermanently(self._branch.url(
+                      '../changes'))
 
         revid = h.fix_revid(args[0])
         file_id = args[1]

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2010-12-01 08:30:02 +0000
+++ loggerhead/highlight.py	2010-04-22 03:23:55 +0000
@@ -16,7 +16,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import bzrlib.osutils
 import cgi
 
 from pygments import highlight as _highlight_func
@@ -37,7 +36,7 @@
     """
 
     if len(text) > MAX_HIGHLIGHT_SIZE:
-        return map(cgi.escape,  bzrlib.osutils.split_lines(text))
+        return map(cgi.escape, text.split('\n'))
 
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
@@ -49,7 +48,6 @@
         except (ClassNotFound, ValueError):
             lexer = TextLexer(encoding=encoding)
 
-    hl_lines = _highlight_func(text, lexer, formatter)
-    hl_lines = bzrlib.osutils.split_lines(hl_lines)
+    hl_lines = _highlight_func(text, lexer, formatter).split('\n')
 
     return hl_lines

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2010-05-10 13:48:25 +0000
+++ loggerhead/history.py	2010-04-23 01:30:29 +0000
@@ -152,9 +152,6 @@
                 filename=rich_filename(paths[1], kind),
                 file_id=file_id))
 
-# The lru_cache is not thread-safe, so we need a lock around it for
-# all threads.
-rev_info_memory_cache_lock = threading.RLock()
 
 class RevInfoMemoryCache(object):
     """A store that validates values against the revids they were stored with.
@@ -178,11 +175,7 @@
         If a value was stored under `key`, with the same revid, return it.
         Otherwise return None.
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            cached = self._cache.get(key)
-        finally:
-            rev_info_memory_cache_lock.release()
+        cached = self._cache.get(key)
         if cached is None:
             return None
         stored_revid, data = cached
@@ -194,11 +187,7 @@
     def set(self, key, revid, data):
         """Store `data` under `key`, to be checked against `revid` on get().
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            self._cache[key] = (revid, data)
-        finally:
-            rev_info_memory_cache_lock.release()
+        self._cache[key] = (revid, data)
 
 # Used to store locks that prevent multiple threads from building a 
 # revision graph for the same branch at the same time, because that can
@@ -294,7 +283,6 @@
         else:
             self._file_change_cache = None
         self._branch = branch
-        self._branch_tags = None
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
         self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
@@ -665,12 +653,11 @@
         """
         message, short_message = clean_message(revision.message)
 
-        if self._branch_tags is None:
-            self._branch_tags = self._branch.tags.get_reverse_tag_dict()
+        tags = self._branch.tags.get_reverse_tag_dict()
 
         revtags = None
-        if revision.revision_id in self._branch_tags:
-          revtags = ', '.join(self._branch_tags[revision.revision_id])
+        if tags.has_key(revision.revision_id):
+          revtags = ', '.join(tags[revision.revision_id])
 
         entry = {
             'revid': revision.revision_id,

=== renamed file 'loggerhead/static/css/view.css' => 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/view.css	2010-12-01 08:30:02 +0000
+++ loggerhead/static/css/annotate.css	2009-04-30 10:39:05 +0000
@@ -1,31 +1,29 @@
 /*table*/
-.viewLineTit, .viewLine, .viewRevTit, .viewRev,
-.viewContTit, .viewCont
-{
+.annoLineTit, .annoLine, .annoRevTit, .annoRev, .annoComm, .annoCommTit, .annoContTit, .annoCont {
+	width:45px;
 	border:1px solid #d2d2d2;
 }
-.viewLine, .viewRev, .viewComm, .viewCont {
+.annoLine, .annoRev, .annoComm, .annoCont {
 	border:none;
 }
-.viewLine, .viewLineTit {
-	padding-right: .2em;
-}
-.viewLine {
+.annoLine {
 	width:37px;
 }
-.viewContTit, .viewCont {
+.annoContTit, .annoCont {
 	width:auto;
-	padding-left: .3em;
 }
-.viewRevTit, .viewRev {
+.annoRevTit, .annoRev {
 	width:70px;
 	text-align:center;
 }
-.viewLine, .viewCont {
+.annoComm, .annoCommTit {
+	width:200px;
+}
+.annoLine, .annoCont {
 	font:normal 12px/normal monospace;
         whitespace: pre;
 }
-.viewCont pre { margin: 0; }
-.viewLine {
+.annoCont pre { margin: 0; }
+.annoLine {
 	text-align:right;
 }

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2010-12-01 08:30:02 +0000
+++ loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
@@ -121,9 +121,9 @@
 
 
 @templatefunc
-def view_link(url, revno, path):
+def annotate_link(url, revno, path):
     return '<a href="%s" title="Annotate %s">%s</a>' % (
-        url(['/view', revno, path]), cgi.escape(path), cgi.escape(path))
+        url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):

=== renamed file 'loggerhead/templates/view.pt' => 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/view.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/annotate.pt	2009-04-30 10:39:05 +0000
@@ -3,12 +3,12 @@
 <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
   <head>
     <title metal:fill-slot="title"
-           tal:content="string:${branch/friendly_name} : contents of ${file_path}
+           tal:content="string:${branch/friendly_name} : contents of ${path}
                         at revision ${change/revno}">
     </title>
     <metal:block fill-slot="header_extras">
         <link rel="stylesheet" type="text/css" media="all"
-              tal:attributes="href python:branch.static_url('/static/css/view.css')"/>
+              tal:attributes="href python:branch.static_url('/static/css/annotate.css')"/>
         <link rel="stylesheet" type="text/css" media="all"
               tal:attributes="href python:branch.static_url('/static/css/highlight.css')"/>
     </metal:block>
@@ -36,14 +36,6 @@
             <li id="first">
                 <a tal:attributes="href python:url(['/files', change.revno], clear=1)">browse files</a>
             </li>
-            <li tal:condition="not:annotated">
-              <a tal:attributes="href python:url(['/annotate', revno_url, file_path], clear=1)"
-              >view revision numbers per line</a>
-            </li>
-            <li tal:condition="annotated">
-              <a tal:attributes="href python:url(['/view', revno_url, file_path], clear=1)"
-              >view without revision numbers</a>
-            </li>
             <li>
                 <a tal:attributes="href python:url(['/revision', change.revno], clear=1)">view revision</a>
             </li>
@@ -58,30 +50,25 @@
             </li>
         </ul>
 
-      <div class="view">
+      <div class="annotate">
         <table id="logentries">
           <tr class="logheader">
-            <td class="viewLineTit">Line</td>
-            <td class="viewRevTit" tal:condition="annotated">Revision</td>
-            <td class="viewContTit">Contents</td>
+            <td class="annoLineTit">Line</td>
+            <td class="annoRevTit">Revision</td>
+            <td class="annoContTit">Contents</td>
           </tr>
 
-          <tal:rep tal:repeat="line contents">
-            <tr tal:define="anno python:annotated and annotated.next()"
-                tal:attributes="class python:anno and 'blueRow' + str(anno.parity) or None">
-              <td class="viewLine">
-                <a tal:attributes="id string:L${repeat/line/number}; href string:#L${repeat/line/number}"
-                   tal:content="repeat/line/number">1</a>
-              </td>
-              <td class="viewRev" tal:condition="annotated">
-                <a tal:condition="python:anno.new_rev"
-                   tal:content="python:util.trunc(anno.change.revno)"
-                   tal:attributes="href python:url(['/revision', anno.change.revno], clear=1);
-                                   title python:'%s by %s, on %s (%s)' % (anno.change.revno, ', '.join(util.hide_emails(anno.change.authors)), anno.change.date.strftime('%d %b %Y %H:%M'), util.date_time(anno.change.date))"></a>
-              </td>
-              <td class="viewCont"><pre tal:content="structure line"></pre></td>
-            </tr>
-          </tal:rep>
+          <tr tal:repeat="line contents"
+              tal:attributes="class string:blueRow${line/parity}">
+            <td class="annoLine"><a tal:attributes="id string:L${line/lineno}; href string:#L${line/lineno}" tal:content="line/lineno">1</a></td>
+            <td class="annoRev">
+              <a tal:condition="python:line.status=='changed'"
+                 tal:content="python:util.trunc(line.change.revno)"
+                 tal:attributes="href python:url(['/revision', line.change.revno], clear=1);
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, ', '.join(util.hide_emails(line.change.authors)), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+            </td>
+            <td class="annoCont"><pre tal:content="structure line/text"></pre></td>
+          </tr>
         </table>
       </div>
 

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2010-05-05 18:42:58 +0000
+++ loggerhead/templates/atom.pt	2009-06-06 12:23:11 +0000
@@ -4,8 +4,8 @@
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
   <updated tal:content="string:${updated}Z">${updated}</updated>
-  <id tal:content="python:branch.absolute_url(['/atom'])">url</id>
-  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.absolute_url(['/atom'])" />
+  <id tal:content="python:branch.url(['/atom'])">url</id>
+  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.url(['/atom'])" />
   <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
 
   <entry tal:repeat="entry changes">
@@ -16,7 +16,7 @@
       updated
     </updated>
     <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
-    <id tal:content="python:branch.absolute_url(['/revision', entry.revno])">
+    <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
     <author tal:repeat="author entry/authors">

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/inventory.pt	2009-10-17 06:55:25 +0000
@@ -89,11 +89,11 @@
 
             <!-- Show this if it's a symlink -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
-                <td class="autcell"><a tal:attributes="href python:url(['/view', change.revno, file.absolutepath])">
+                <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -113,17 +113,17 @@
 
             <!-- Show this if it's a regular file -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='file'">
-                <td class="autcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])">
+                <td class="autcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
-                                             title string:View ${file/filename}"
+                                             title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
-                                             title string:View ${file/filename}"
+                                             title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>
 
-              <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
+              <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                      tal:content="file/filename" class="link"></a></td>
               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
                                                   title string:Show revision ${file/change/revno}"
@@ -131,8 +131,8 @@
               </td>
               <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
               <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
-              <td class="expcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath]);
-                                                     title string:View ${file/filename}">
+              <td class="expcell"><a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath]);
+                                                     title string:Annotate ${file/filename}">
                                       <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
                                      </a>
               </td>

=== modified file 'loggerhead/templates/menu.pt'
--- loggerhead/templates/menu.pt	2011-02-09 22:33:59 +0000
+++ loggerhead/templates/menu.pt	2008-08-14 22:45:52 +0000
@@ -13,6 +13,8 @@
         <li><a tal:attributes="href python:url('/files', clear=1);
                                title string:Files;
                                id string:on">Files</a></li>
+        <li><a tal:attributes="href string:https://help.launchpad.net/Loggerhead;
+                               title string:Help">Help</a></li> 
         </tal:fileview-active>
       </ul>
 </tal:menu>

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2010-12-01 08:30:02 +0000
+++ loggerhead/templates/revision.pt	2009-07-21 04:39:33 +0000
@@ -41,7 +41,7 @@
             </tal:compare-to>
           </span>
           <span class="breadcrumb" tal:condition="specific_path">
-            : <tal:annotate content="structure python:view_link(url, change.revno, specific_path)" />
+            : <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
           </span>
         </h1>
         <tal:branch-info replace="structure python:branchinfo(branch)" />
@@ -54,7 +54,7 @@
           </a>
         </p>
         <p tal:condition="specific_path">
-          Viewing changes to <tal:annotate content="structure python:view_link(url, change.revno, specific_path)" />
+          Viewing changes to <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
         </p>
         <ul id="submenuTabs">
           <li id="first"><a tal:attributes="href python:url(['/files', change.revno]);

=== modified file 'loggerhead/tests/__init__.py'
--- loggerhead/tests/__init__.py	2010-05-10 19:36:37 +0000
+++ loggerhead/tests/__init__.py	2006-12-11 06:44:19 +0000
@@ -1,26 +0,0 @@
-# Copyright 2006, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-def load_tests(standard_tests, module, loader):
-    standard_tests.addTests(loader.loadTestsFromModuleNames([
-        (__name__ + '.' + x) for x in [
-            'test_controllers',
-            'test_corners',
-            'test_simple',
-            'test_templating',
-        ]]))
-    return standard_tests

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-02-09 22:35:16 +0000
+++ loggerhead/tests/test_controllers.py	2009-03-19 18:48:15 +0000
@@ -61,25 +61,20 @@
 
     def make_annotate_ui_for_file_history(self, file_id, rev_ids_texts):
         tree = self.make_branch_and_tree('.')
-        self.build_tree_contents([('filename', '')])
+        open('filename', 'w').write('')
         tree.add(['filename'], [file_id])
         for rev_id, text in rev_ids_texts:
-            self.build_tree_contents([('filename', text)])
+            open('filename', 'w').write(text)
             tree.commit(rev_id=rev_id, message='.')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
-        branch_app = BranchWSGIApp(tree.branch, friendly_name='test_name')
+        branch_app = BranchWSGIApp(tree.branch)
         return AnnotateUI(branch_app, branch_app.get_history)
 
     def test_annotate_file(self):
         history = [('rev1', 'old\nold\n'), ('rev2', 'new\nold\n')]
         ann_ui = self.make_annotate_ui_for_file_history('file_id', history)
-        # A lot of this state is set up by __call__, but we'll do it directly
-        # here.
-        ann_ui.args = ['rev2']
-        annotate_info = ann_ui.get_values('filename',
-            kwargs={'file_id': 'file_id'}, headers={})
-        annotated = list(annotate_info['annotated'])
+        annotated = list(ann_ui.annotate_file('file_id', 'rev2'))
         self.assertEqual(2, len(annotated))
         self.assertEqual('2', annotated[0].change.revno)
         self.assertEqual('1', annotated[1].change.revno)

=== modified file 'loggerhead/trace.py'
--- loggerhead/trace.py	2010-11-12 00:09:49 +0000
+++ loggerhead/trace.py	2008-10-24 02:26:05 +0000
@@ -22,7 +22,6 @@
 
 import os
 import logging
-import logging.handlers
 import sys
 
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2010-04-28 21:41:32 +0000
+++ loggerhead/util.py	2010-04-23 01:30:29 +0000
@@ -156,11 +156,11 @@
 
     def __getattr__(self, attr):
         """Used for handling things that aren't already available."""
-        if attr.startswith('_') or attr not in self._properties:
-            raise AttributeError('No attribute: %s' % (attr,))
-        val = self._properties[attr](self, attr)
-        setattr(self, attr, val)
-        return val
+        if attr in self._properties:
+            val = self._properties[attr](self, attr)
+            setattr(self, attr, val)
+            return val
+        raise AttributeError('No attribute: %s' % (attr,))
 
     def _set_property(self, attr, prop_func):
         """Set a function that will be called when an attribute is desired.
@@ -168,8 +168,6 @@
         We will cache the return value, so the function call should be
         idempotent. We will pass 'self' and the 'attr' name when triggered.
         """
-        if attr.startswith('_'):
-            raise ValueError("Cannot create properties that start with _")
         self._properties[attr] = prop_func
 
 

